package Poputil;

import javax.swing.*;
import javax.swing.table.*;
import java.util.Vector;
import nettoyeur.Progress;

/**
 *
 * <h3>Description : </h3>
 * <p>implmente Interfacepoputil</p>
 * @author yarel
 * @version 1.0
 */
public class Ctrlpoputil
    implements Interfacepoputil {

  private Pop pop;

  private Msgs colMsgs;

  /**
   * connection
   * @param serveur String
   * @param port int
   * @return boolean
   */
  public boolean connectPop(String serveur, int port) {
    this.pop = new Pop();
    return this.pop.connectPop(serveur, port);

  }

  /**
   * login
   * @param user String
   * @param password String
   * @return boolean
   */
  public boolean loginPop(String user, String password) {
    return this.pop.login(user, password);
  }


  /**
   * renvoie la chaine
   * avec des cars accentu
   * pour le champs "Sujet"
   * @param chaine String
   * @return String
   */
  private String formatChaine(String chaine) {
    String champ = ""; //le nom du champ (si from ou to ou subject)
    String mel = ""; //la fin de la chaine si from ou to
    String strtmp = ""; //la chaine  traiter
    if (chaine != null) {
      int debutchainehexa = 0;
      int finchainehexa = 0;
     if(chaine.startsWith("From") || chaine.startsWith("To") || chaine.startsWith("from") || chaine.startsWith("to")){
         mel = this.formatMel(chaine);
         return mel;
      }
      if ((chaine.indexOf("=?") != -1 && chaine.lastIndexOf("?=") != -1)
          && (chaine.indexOf("q") != -1 || chaine.indexOf("Q") != -1)
          && (chaine.indexOf(":") != -1)){ //contient tout les marqueurs qui indiquent des caracteres accentus ?

        chaine = chaine.toLowerCase(); //en minuscule pour le "q" ou "Q" (Quoted printable)
        champ = chaine.substring(0, chaine.indexOf(":"));//toujours aprs le nom du champs
        debutchainehexa = chaine.indexOf("q") + 2;
        finchainehexa = chaine.lastIndexOf("?=");
        strtmp = chaine.substring(debutchainehexa, finchainehexa); //que la partie encode

        if (strtmp.indexOf("=") != -1) { //y'a des caractres accentus cods ?
          String strValHexa = "";
          int pos = 0;
          for (int i = 0; i < strtmp.length(); i++) {//pour chaque caractere
            if (strtmp.indexOf("=") == -1) {
              break; //y'a plus de "=" on sort
            }
            else {
              pos = strtmp.indexOf("="); //recherche la position du "="
              strValHexa = strtmp.substring(pos + 1, pos + 3); //prend les 2 caracteres suivants(valeur hexa)
              strtmp = strtmp.replaceAll("=" + strValHexa,
                                         this.decodePass(strValHexa)); //remplace les deux caracteres (val hexa) par le car accentu
              i = pos; //pas la peine de faire tous les caractere entre 2 "="
            }
          }
          if (strtmp.indexOf("_") != 1) {//y'a des "_" ?
            strtmp = strtmp.replaceAll("_", " ");//remplac par des espaces
          }
          return  strtmp + " " + mel; //c'est bon :)
        }
        else {
          return chaine.substring(chaine.indexOf(":")+1,chaine.length());
        }
      }
      else {
        return chaine.substring(chaine.indexOf(":")+1,chaine.length());
      }
    }
    else {
      return chaine;

    }
  }


  /**
   * decode la valeur hexa de la chaine
   * @param champ String
   * @return String
   */
  private String decodePass(String champ) {
    String str = new String();
    for (int i = 0; i < champ.length(); i += 2) {
      try {
        str += (char) Integer.parseInt(champ.substring(i, i + 2), 16);
      }
      catch (NumberFormatException ne) {
      }
    }
    return str;
  }

  /**
   * renvoi uniquement l'adresse mel
   * pour les champs "from" & "To"
   * @param mel String
   * @return String
   */
  private String formatMel(String mel){
    if(mel.indexOf("<") != -1 && mel.indexOf(">") != -1){
      return mel.substring(mel.indexOf("<"), mel.indexOf(">")+1);
    }
    else{
      if(mel.indexOf("@") != -1){
        int arobase = mel.indexOf("@");
        String finmel = mel.substring(arobase,mel.length());
        if(mel.indexOf(" ") == -1){
          String debutmel = mel.substring(0, arobase);
          return debutmel+finmel;
        }
        else{
          String debutmel = mel.substring(mel.indexOf(" "), arobase);
          return "<"+debutmel+finmel+">";
        }
      }
      else{
        return mel;
      }
    }
  }


  /**
   * remplit le collection
   * de msg
   * @param colMsg Msgs
   * @param bar Progress
   */

  public void afficheMsgs(Msgs colMsg, Progress bar) {
    String[] champs = new String[4];
    int nbrTotalMsg = this.pop.getN_NbrTotalMsg();
    int navance =  ((100-bar.getTotalBar())/(nbrTotalMsg));
    int j = 0;
    for (int i = 1; i <=nbrTotalMsg; i++) {
      String[] mess = this.pop.extractHeader(i);
      if (mess != null) {
        bar.setOut("Lecture du message N : "+ i);
        bar.avanceBar(navance);
        for(j=0; j< mess.length;j++){
          champs[j] = this.formatChaine(mess[j]);
        }
        colMsg.ajouteMsg(champs, i);
      }
      else {
        bar.setOut("prb :  message N : "+ i +"affichemsgs() fichier : ctrlpoputil");
      }
    }
  }

  /**
   * efface un mel sur le serveur
   * @param numeromel int
   * @return boolean
   */
  public boolean killSpam(int numeromel) {
    return this.pop.killSpam(numeromel);
  }

  /**
   * renvoi le nombre total de mel
   * @return int
   */
  public int getNbrTotalMsg() {
    this.pop.listMsg();
    return this.pop.getN_NbrTotalMsg();
  }

  /**
   * constructeur
   */
  public Ctrlpoputil() {

  }

  /**
   * logout
   * @return String
   */
  public String quitConnect() {
    return this.pop.logout();
  }
}
