package nettoyeur;

import javax.swing.table.DefaultTableModel;
import java.util.Vector;
import javax.swing.table.TableColumn;
import javax.swing.JTable;
import javax.swing.BorderFactory;
import javax.swing.table.JTableHeader;
import java.awt.Color;

class Modelmel extends DefaultTableModel {

  private String[] _colums;

  private String[][] _lignes;

  private JTable melTab;

  private TableColumn _colUn;

  private JTableHeader headtable;


  /**
   * tableau d'objet (string)
   * des noms des colonnes
   * nbr de lignes
   * table  remplir
   * @param columnNames objet
   * @param rowCount int
   * @param table JTable
   */
 Modelmel(Object[] columnNames, int rowCount, JTable table) {
    super(columnNames, rowCount); //la base du model
    _colums = (String[])columnNames; //le nom des colonnes
    melTab = table; // la table (vide) de Fnet
    construit(); // fabrique et applique le model dans la table
  }


 Modelmel(int columnCount, int rowCount) {
    super(columnCount, rowCount);
  }

  public JTable getTablemodel(){
    return this.melTab;
  }


  private void construit(){
    melTab.setModel(this);
    melTab.setBorder(BorderFactory.createEtchedBorder());
    melTab.setColumnSelectionAllowed(false);
    melTab.setBackground(new Color(255, 255, 229));
    melTab.setRowHeight(25);
    headtable = new JTableHeader();
    headtable = melTab.getTableHeader();
    headtable.setReorderingAllowed(false); //interdit le deplacement des colonnes
    melTab.setTableHeader(headtable);
    _colUn = melTab.getColumnModel().getColumn(0);
    _colUn.setMaxWidth(10);
    _colUn.setResizable(false);

  }

  /**
   * remplit avec les donnees
   * contenu dans lignes
   * @param lignes String[][]
   * met la table  jour
   */
  public void remplirModel(String[][] lignes){
    _lignes = lignes;
    setDataVector(_lignes,_colums);
    construit();
    fireTableDataChanged();
  }

  /**
   * vide la table
   */
  public void effaceLignes(){

    while(getRowCount() > 0){
      removeRow(0);
    }
    fireTableDataChanged();
  }
  /**
   * efface des lignes
   * @param numligne int[]
   */
  public void effaceLignes(int[] numligne){
    for(int i = 0; i<numligne.length; i++){
      removeRow(numligne[i]-i);
    }
    fireTableDataChanged();
  }

  /**
   * surcharge afin de rendre
   * la jtable non ditable
   */
  public boolean isCellEditable(int row, int col){
    return false;
  }
}
