package nettoyeur;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;
/**
 * <p>Titre : Progress barre</p>
 * <p>Description : Barre de progressoin pendant la recherche de mel</p>
 * @author yarel@tiscali.fr
 * @version 0.0.1
 */

public class Progress extends JFrame {
  GridLayout gridLayout1 = new GridLayout();
  JLabel lblprogress = new JLabel();
  JProgressBar jProgressBar1 = new JProgressBar();
  TitledBorder titledBorder1;
  JButton jButton1 = new JButton();
  static int nDecalage = 0;

  /***************************
   * constructeur
   * initialise les composants
   *****************************/

  public Progress(){
    try{
      jbInit();
    }
    catch(Exception ex){
      ex.printStackTrace();
    }
  }

  /***********************
   * construit l'interface
   * @throws Exception throws
   ***********************/
  private void jbInit() throws Exception{
    gridLayout1.setColumns(1);
    gridLayout1.setRows(3);
    this.getContentPane().setLayout(gridLayout1);

    jProgressBar1.setBorder(BorderFactory.createLoweredBevelBorder());
    jButton1.setText("Annuler");
    jButton1.addActionListener(new Progress_jButton1_actionAdapter(this));
    this.getContentPane().add(lblprogress, null);
    this.getContentPane().add(jProgressBar1, null);
    this.getContentPane().add(jButton1, null);
    this.setSize(new Dimension(500, 80));
    lblprogress.setText("progression");
    jProgressBar1.setPreferredSize(new Dimension(420, 10));
    jProgressBar1.setStringPainted(true);
    lblprogress.setSize(new Dimension(440,25));
    jProgressBar1.setValue(0);
    jProgressBar1.setString("0%");
    Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = this.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    if(nDecalage > 250){
      nDecalage = 0;
    }
    nDecalage = nDecalage + 50;
    int nlargeur =  (((screenSize.width - frameSize.width) / 2) + nDecalage);
    int nlongueur = (((screenSize.height - frameSize.height) / 2) + nDecalage);
    this.setLocation(nlargeur, nlongueur);
   this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
   this.setVisible(true);

  }

  /*****************************
  *ajoute la valeur en parametre
  * @param pourcent int
  *******************************/
  public void avanceBar(int pourcent){
        int val = jProgressBar1.getValue();
        jProgressBar1.setValue(val+pourcent);
        jProgressBar1.setString(val+pourcent+"%");
  }

  /**
   * affiche le texte sur la progresse barre
   * @param out String
   */
  public void setOut(String out){

          lblprogress.setText(out);
  }

  /**
   * affiche le titre
   * @param titre String
   */
  public void setTitre(String titre){
    this.setTitle(titre);
  }

  /**
   * retourne la valeur total
   * de l'avancement de la barre
   * @return int
   */
  public int getTotalBar(){
    return jProgressBar1.getValue();
  }

  /**
   * annuler
   * @param e ActionEvent
   */
  void jButton1_actionPerformed(ActionEvent e) {
    this.setOut("Action annule");
    this.setVisible(false);
    this.dispose();
  }



}

class Progress_jButton1_actionAdapter implements java.awt.event.ActionListener {
  Progress adaptee;

  Progress_jButton1_actionAdapter(Progress adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton1_actionPerformed(e);
  }
}
