package nettoyeur;

import java.awt.Dimension;
import javax.swing.JTable;

import svgard.Comptepop;
import Poputil.Ctrlpoputil;
import Poputil.Msgs;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import java.util.Vector;
import javax.swing.JFrame;


/***********************
 * @author yarel
 *
 ***********************/

public class Thdleon extends Thread {
  private Progress pBar;
  private Comptepop compteX;
  private Ctrlpoputil chekCompte;
  private Principale parent;
  private Modelmel tabMel;
  private Msgs colMsg;
  private boolean bstop;
  private String tablibele;


   /**
    * constructeur
    * @param compte CmptPop
    * @param modelm ModelMel
    * @param parent JFrame
    * @param lbltab String
    */
   Thdleon(Comptepop compte, Modelmel modelm, Principale parent, String lbltab) {
     this.chekCompte = new Ctrlpoputil(); //interface Pop (connection...)
     this.compteX = compte;
     this.parent = parent;
     this.tabMel = modelm;
     this.tablibele = lbltab;
     construit();
   }

   /**
    * initialisation
    */
   private void construit(){
     try{
       this.pBar = new Progress();
       //this.parent.setVisible(false);
       //this.parent.setEnabled(false);
       this.colMsg = new Msgs();
       this.bstop = false;
     }
     catch(Exception bug){
       bug.printStackTrace();
     }
   }

   /**
    * endort le thread
    * @param temps int
    */
   public void dodo(int temps) {
     try {
       Thread.sleep(temps);
     }
     catch (InterruptedException popi) {

     }
   }

   /**
    * renvoi la table
    *
    * @return tabmel
    */
   public Modelmel getTab(){

     return this.tabMel;
   }

   /**
    * lit les parametres du pop
    * affiche la progressBar
    * @return boolean
    */
   public boolean getPop() {
     if (compteX != null) {
       pBar.setTitre(compteX.getStr_user());
       pBar.setOut("Vrification des messages sur : " + compteX.getStr_serveur() +
                   "\n"
                   + " pour l'utilisateur : " + compteX.getStr_user() + "\n");
       pBar.avanceBar(10);
       dodo(1000);
       return true;
     }
     else {
       pBar.setOut("impossible de lire le compte");
       dodo(1000);
       //termine();
       return false;
     }
   }

   /**
    * connection au serveur pop3
    * affiche le droulement
    * dans la progressBar
    * @return boolean
    */
   public boolean connect() {

     Integer tmpport = new Integer(compteX.getStr_port()); //le port est un 'String' dans l'objet compte
     int nport = tmpport.intValue(); //transforme en 'int'
     if (chekCompte.connectPop(compteX.getStr_serveur(), nport)) {
       pBar.setOut("Connection OK" + "\n" + "   Login..." + "\n");
       pBar.avanceBar(10);
       dodo(1000);
       return true;
     }
     else {
       pBar.setOut("connection impossible");
       dodo(1000);
       //termine();
       return false;
     }
   }

   /**
    * login au pop3
    * @return boolean
    */
   public boolean login() {
     if (chekCompte.loginPop(compteX.getStr_user(),
                             compteX.getStr_pass())) { //essai login (user, pass)
       pBar.setOut("Login OK" + "\n" + "    Recherche le nombre de message..." +
                   "\n");

       pBar.avanceBar(10);
       dodo(1000);
       return true;
     }
     else {
       pBar.setOut("login impossible");
       this.dodo(1000);
       //termine();
       return false;
     }
   }

   /**
    * liste les mels sur le pop3
    * affiche les enttes
    * conserve la connection
    * si pas de mel deconnecte
    */
   public void transfer() {
     String[][] lignes = null;
     if (chekCompte.getNbrTotalMsg() > 0) { //recup le nombre de msg sur le serveur

       pBar.setOut("il y a :  " + chekCompte.getNbrTotalMsg() + "  Messages" +
                   "\n" +
                   "   Affichage des enttes" + "\n");
       //avance la progressBAr
       chekCompte.afficheMsgs(colMsg, pBar);//remplit la collection avec les mels du pop

       int nbrMesg = colMsg.getNbrTotalMsg(); //le nbr de message dans la collection
       lignes = new String[nbrMesg][5];
       //transfert la collection dans le modele de la jtable
       for (int i = 0; i < nbrMesg; i++) {
         Integer num = new Integer(colMsg.getMsg(i).getN_Num());
         String strnum = num.toString();
         lignes[i][0] = strnum;
         lignes[i][1] = colMsg.getMsg(i).getStr_From();
         lignes[i][2] = colMsg.getMsg(i).getStr_To();
         lignes[i][3] = colMsg.getMsg(i).getStr_Subject();
         lignes[i][4] = colMsg.getMsg(i).getStr_Date();
       }
       tabMel.remplirModel(lignes);
       colMsg.delAllMsg(); //vide la collection
       colMsg = null;
     }
     else {
       pBar.setOut("Pas de messages  Dconnection...");
       pBar.avanceBar(50);
       dodo(1000);
       pBar.avanceBar(20);
       pBar.setOut(chekCompte.quitConnect()); //ferme la connection
       dodo(1000);
       termine();
       parent.KillFacteur(this, this.tablibele);
     }

   }

   /**
    *
    * efface les messages sur le serveur
    * et dans la table
    * @param nummel int
    * @param numligne int
    * @return boolean
    */
   public boolean killSpams(int[] numligne, int[] nummel){
     //nummel = les n des mels sur le serveur
    for(int i = 0; i< nummel.length; i++){
       if(!chekCompte.killSpam(nummel[i])){ //efface sur le serveur
         return false;
       }
       else{
         continue;
       }
     }
     tabMel.effaceLignes(numligne); //efface lles lignes de la table
     return true;
   }

   /**
    * deconnection
    * @return String
    */
   public String disconnect(){
     tabMel.effaceLignes(); //efface toute les lignes de la table mel
     termine();
     return chekCompte.quitConnect(); //ferme la connection


   }

   /**
    * stop le thread
    */

   private void killThread(){
     bstop = true;
   }

   /**
    * ferme la progressBar
    * rend la main  fnet
    */

   public void termine(){
     pBar.dispose();
     parent.setEnabled(true);
     killThread();
   }

   /**
    * "suicideur"
    */
   public void detruitVpop(){
     parent.KillFacteur(this, this.tablibele);
   }

   /**
    * le droulement du relev
    */
   private void scenario(){
     if(getPop()){
       if(connect()){
         if(login()){
           transfer();
           termine();
         }
         else{
          termine();
          detruitVpop();
         }
       }
       else{
         termine();
         detruitVpop();
       }
     }
     else{
       termine();
       detruitVpop();
     }
   }

   /**
    * mthode de la class thread
    */
   public void run() {
     while (bstop == false) {
       try {
         scenario();
         if (bstop) {
           break;
         }
       }

       catch (Exception ex) {
         pBar.setVisible(true);
         pBar.setOut("ERREUR exeption du scenario du thread thdleon");
         dodo(1000);
         termine();
       }
     }
   }
 }
