/*
 * Created on 2 nov. 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package svgard;
import java.io.*;


/***********************
 * @author yarel
 *
 ***********************/
public class Fichierpop {
  private String nom_Fichier;
  /*les prefix text dans le fichier*/
  private static final String P_PREFIX = System.getProperty("user.dir");
  private static final String P_PATH = "data";
  private static final String P_SERVEUR = "serveur=";
  private static final String P_USER = "user=";
  private static final String P_PORT = "port=";
  private static final String P_PASSWORD = "password=";

  /*tableau de noms de fichiers "pop" contenu dans le rep data*/
  private String[] fichiers_pop;

  /**
   * ecrit les parametres du compte pop dans un fichier
   * creer le fichier s'il n'existe pas
   * l'ecrase sinon
   * @param compte Comptepop
   * @return boolean
   */
  boolean EcrireCmptPop(Comptepop compte) {
    this.nom_Fichier =  compte.getStr_user()+".kds";
    try {
      File fichierpop = new File(P_PREFIX+
                                 File.separator+P_PATH+File.separator+
                                 this.nom_Fichier);
      PrintWriter ligne = new PrintWriter(new FileWriter(fichierpop));
      ligne.println(P_SERVEUR + compte.getStr_serveur());
      ligne.println(P_USER + compte.getStr_user());
      ligne.println(P_PORT + compte.getStr_port());
      ligne.println(P_PASSWORD + this.encodePass(compte.getStr_pass()));
      ligne.close();
      return true;
    }
    catch (Exception eio) {
      System.out.print(P_PREFIX+
                                 File.separator+P_PATH+File.separator+
                                 this.nom_Fichier);
      return false;
    }
  }

  /**
   * liste les fichiers pop
   * dans le rep 'data'
   * remplit le tableau 'fichiers_pop'
   * avec les noms des fichiers
   * @return int
   */
  int listeRepCompte() {
    int nbrtotalpop = 0;
    String tmp = P_PREFIX;	//cherche le rep courant
    String chemin = "";
    try{

            if(tmp.endsWith(".jar")){	//si archive "jar"
                        chemin = tmp.substring(0,tmp.lastIndexOf(File.separator))+File.separator+P_PATH;
            }
            else{	//sinon
              chemin = tmp+File.separator+P_PATH;
            }
        File reppop = new File(chemin);
        File listpop[] = reppop.listFiles();

            if(!reppop.exists()){
           System.err.println("Dossier : " +chemin+" introuvable");
           return -1;
            }
        if(!reppop.canRead()){
          System.err.println("Ouverture de :" +chemin+ " impossible");
          return -2;
        }

            this.fichiers_pop = new String[listpop.length]; //absolument initialiser le tableau de string !!
            for (int i = 0; i < listpop.length; i++) {
              /*verif le nbr du nom du fichier si nom = ".kds"*/
                      if (listpop[i].isFile() && listpop[i].canRead() && listpop[i].getName().substring(0).endsWith(".kds") && (listpop[i].getName().length() > 4)) {
                        this.fichiers_pop[nbrtotalpop] = listpop[i].getPath(); //le chemin + le nom du fichier
                        nbrtotalpop++;
                      }
            }
            return nbrtotalpop;
    }
    catch(SecurityException sex){

            return -2;
    }
    catch(NullPointerException nex){

            return -1;
    }
  }

  /**
   * retourne le tableau de nom de fichier
   * @return String[]
   */
  String[] fichiersPop() {
    return this.fichiers_pop;
  }

  /**
   * lit le fichier en paramtre
   *et retourne les lignes
   *dans un tableau de string
   *fichierpop (chemin + fichier)
   *@param fichierpop String
   * @return String[]
   */
  String[] lireCompte(String fichierpop) {
    String[] parametres = new String[4]; //nombre de ligne ( modifier en cas d'ajout de parametre dans le fichier)
    try {
      BufferedReader lirepop = new BufferedReader(new FileReader(fichierpop));
      int i = 0;
      int pos;
      String ligne;
      while ( (ligne = lirepop.readLine()) != null) { //tant qu'i y a des lignes
        pos = ligne.indexOf("="); //recherche le separateur
        if (i == 3) {
          parametres[i] = this.decodePass(ligne.substring(pos + 1)); //decode le password
        }
        else {
          parametres[i] = ligne.substring(pos + 1); //la valeur du parametre
        }
        i++;
      }
      lirepop.close();
    }
    catch (IOException eio) {
      eio.printStackTrace();
    }
    return parametres;
  }

  /**
   * conctructeur
   */
  Fichierpop() {
  }

  boolean Supprimercompte(String servername) {
    File supprimepop = new File(P_PATH + servername);
    return supprimepop.delete();
  }

  /**
   * encode le password
   * stock dans le fichier
   * @param password String
   * @return String
   */
  private String encodePass(String password) {
    String result = new String();
    for (int i = 0; i < password.length(); i++) {
      result += Integer.toHexString(password.charAt(i));
    }
    return result;
  }

  /**
   * decode le password
   * @param password String
   * @return String
   */
  private String decodePass(String password) {
    String str = new String();
    for (int i = 0; i < password.length(); i += 2) {
      str += (char) Integer.parseInt(password.substring(i, i + 2), 16);
    }
    return str;
  }
}
